<script>
import { CONTENT_TYPES } from '../../common/content-types';
import { getClient } from '~/plugins/contentful.js';
import { getPageMetadata } from '~/common/meta';
import { SolutionsHero } from '~/components/solutions/index.vue';
import { NextStep } from '~/components/common/index.vue';
import { CardGrid } from '~/components/community/index.vue';
import { FooterEditLinkMixin } from '~/mixins';

export default {
  components: {
    NextStep,
    SolutionsHero,
    CardGrid,
  },
  mixins: [FooterEditLinkMixin],
  nuxtI18n: false,
  async asyncData() {
    try {
      const { items } = await getClient().getEntries({
        content_type: CONTENT_TYPES.PAGE,
        'fields.slug': 'community',
        include: 10,
      });

      const spaceId = items[0].sys.space.sys.id;
      const entryId = items[0].sys.id;

      let ctfHero = {};
      const cardGroups = [];
      items[0].fields.pageContent.forEach((pageBlock) => {
        if (pageBlock.sys.contentType.sys.id === 'eventHero') {
          ctfHero = pageBlock;
        } else if (pageBlock.sys.contentType.sys.id === 'cardGroup') {
          cardGroups.push(pageBlock);
        }
      });

      const metadata = items[0].fields.seoMetadata[0].fields;
      const image = ctfHero.fields.backgroundImage && {
        image_url: ctfHero.fields?.backgroundImage?.fields?.file?.url,
        alt: ctfHero.fields?.backgroundImage?.fields?.title,
      };
      const hero = {
        ...ctfHero.fields?.customFields,
        title: ctfHero.fields?.title,
        subtitle: ctfHero.fields?.description,
        image,
      };
      return { hero, cardGroups, metadata, spaceId, entryId };
    } catch (e) {
      throw new Error(e);
    }
  },
  head() {
    return getPageMetadata(
      this.metadata,
      this.$route.path,
      this.$nuxtI18nHead({ addSeoAttributes: true }),
    );
  },
};
</script>

<template>
  <div>
    <SlpContainer>
      <SolutionsHero :data="hero" />
      <CardGrid
        v-for="cardGroup in cardGroups"
        :key="cardGroup.id"
        :card-group="cardGroup"
      />
    </SlpContainer>
    <SlpContainer variant="gradient">
      <NextStep />
    </SlpContainer>
  </div>
</template>
